<!DOCTYPE html>
<html layout:decorate="~{fragments/layout}">

<head>
	<title>Product Page</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>Product API Page</h1>
		<div>
			<button onclick="openModal()" class="btn btn-primary mb-2">Create</button>
		</div>
		<div id="isiData"></div>
		<script>
			$(function () {
				getAllProduct()
			})

			function getAllProduct() {
				$.ajax({
					url: '/api/product',
					type: 'get',
					contentType: 'application/json',
					success: function (dataResponse) {
						listView(dataResponse)
					}
				})
			}

			function listView(dataResponse) {
				var str = '<table class="table table-hover table-striped" border="1">'
				str += '<thead class="thead-dark">'
				str += '<tr>'
				str += '<th class="text-center">No</th>'
				str += '<th class="text-center">Category ID</th>'
				str += '<th class="text-center">Variant</th>'
				str += '<th class="text-center">Product Initial</th>'
				str += '<th class="text-center">Product Name</th>'
				str += '<th class="text-center">Description</th>'
				str += '<th class="text-center">Price</th>'
				str += '<th class="text-center">Stock</th>'
				str += '<th class="text-center">is Active</th>'
				str += '<th class="text-center" colspan="2">Action</th>'
				str += '</tr>'
				str += '</thead>'
				str += '<tbody>'
				for (var i = 0; i < dataResponse.length; i++) {
					str += '<tr>'
					str += '<td>' + (i + 1) + '</td>'
					str += '<td>' + dataResponse[i].variant.category.categoryName + '</td>'
					str += '<td>' + dataResponse[i].variant.variantName + '</td>'
					str += '<td>' + dataResponse[i].productInitial + '</td>'
					str += '<td>' + dataResponse[i].productName + '</td>'
					str += '<td>' + dataResponse[i].description + '</td>'
					str += '<td>Rp.' + dataResponse[i].price.toFixed(2); + '</td>'
					str += '<td>' + dataResponse[i].stock + 'pcs</td>'
					var checked = dataResponse[i].isActive ? 'checked' : ''
					str += '<td><input type="checkbox" disabled ' + checked + '></td>'
					str += '<td><button class="btn btn-warning" value="' + dataResponse[i].id + '" onClick="f_edit(value)">Update</button></td>'
					str += '<td><button class="btn btn-danger" value="' + dataResponse[i].id + '" onClick="f_delete(value)">Delete</button></td>'
					str += '</tr>'

				}
				str += '</tbody>'
				str += '</table>'


				$('#isiData').html(str)
			}
			function openModal() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (category) {

						$.ajax({
							url: '/api/variant',
							type: 'get',
							contentType: 'application/json',
							success: function (variant) {

								var str = "<form>"
								str += '<div class="form-group">'
								str += '<label>Category</label>'
								str += '<select class="form-control" id="categoryId">'
								str += '<option value="">--Pilih Category--</option>'
								for (var i = 0; i < category.length; i++) {
									str += '<option value="' + category[i].id + '"> ' + category[i].categoryName + ' </option>'
								}
								str += '</select>'
								str += '</div>'
								str += '<div class="form-group">'
								str += '<label>Variant</label>'
								str += '<select class="form-control" id="variantId">'
								str += '<option value="">--Pilih Variant--</option>'
								for (var i = 0; i < variant.length; i++) {
									str += '<option value="' + variant[i].id + '"> ' + variant[i].variantName + ' </option>'
								}
								str += '</select>'
								str += '</div>'
								str += '<div class="form-group">'
								str += '<label>Product Initial</label>'
								str += '<input type="text" class="form-control" id="productInitial">'
								str += '</div>'
								str += '<label>Product Name</label>'
								str += '<input type="text" class="form-control" id="productName">'
								str += '</div>'
								str += '<label>Description</label>'
								str += '<input type="text" class="form-control" id="description">'
								str += '</div>'
								str += '<label>Price</label>'
								str += '<input type="number" class="form-control" id="price">'
								str += '</div>'
								str += '<label>Stock</label>'
								str += '<input type="number" class="form-control" id="stock">'
								str += '</div>'
								str += '<div class="form-group form-check">' 
								str += '<input type="checkbox" class="form-check-input" id="isActive" checked>'
								str += '<label for="isActive">Is Active</label>'
								str += '</div>'
								str += "</form>"

								$(".modal-title").html("Form Product")
								$(".modal-body").html(str)
								$("#btnSave").html("Save Product")
								$("#btnSave").off('click').on('click', saveProduct)
								$("#modal").modal('show')

								onChangeCategory() //Untuk change category(filter data variant berdasarkan category)

							} 
						})
					}
				})
			}

			function onChangeCategory() {
				$("#categoryId").change(function () {
					var categoryId = $(this).val()
					if (categoryId != "") {
						$.ajax({
							url: '/api/product/variantbycategoryid/' + categoryId,
							type: 'get',
							contentType: 'application/json',
							success: function (respon) {
								$("#variantId").empty()
								$("#variantId").append("<option value=''>--Pilih Variant--</option>")
								$.each(respon, function (index, item) {
									$("#variantId").append("<option value='" + item.id + "'> " + item.variantName + " </option>")
								})
							}
						})
					}
					else {
						$("#variantId").empty()
						$("#variantId").append("<option value=''></option>")
					}

				})
			}

			function saveProduct() {
				var formdata = '{'
				formdata += '"variantId":"' + $("#variantId").val() + '",'
				formdata += '"productInitial":"' + $("#productInitial").val() + '",'
				formdata += '"productName":"' + $("#productName").val() + '",'
				formdata += '"description":"' + $("#description").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ','
				formdata += '"price":"' + $("#price").val() + '",'
				formdata += '"stock":"' + $("#stock").val() + '"'
				formdata += '}'

				$.ajax({
					url: '/api/product/add',
					data: formdata,
					type: 'post',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllProduct();
					}
				})
			}

			function f_edit(id) {
				$.ajax({
					url: '/api/product/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (product) {

						$.ajax({
							url: '/api/category',
							type: 'get',
							contentType: 'application/json',
							success: function (category) {

								$.ajax({
									url: '/api/product/variantbycategoryid/' + product.variant.categoryId,
									type: 'get',
									contentType: 'application/json',
									success: function (variant) {

										var str = "<form>"
										str += '<div class="form-group">'
										str += '<label>Category</label>'
										str += '<select class="form-control" id="categoryId">'
										str += '<option value="">--Pilih Category--</option>'
										for (var i = 0; i < category.length; i++) {
											var selected = product.variant.categoryId == category[i].id ? 'selected' : ''
											str += '<option value="' + category[i].id + '" ' + selected + '> ' + category[i].categoryName + ' </option>'
										}
										str += '</select>'
										str += '</div>'
										str += '<div class="form-group">'
										str += '<label>Variant</label>'
										str += '<select class="form-control" id="variantId">'
										str += '<option value="">--Pilih Variant--</option>'
										for (var i = 0; i < variant.length; i++) {
											var selected = product.variantId == variant[i].id ? 'selected' : ''
											str += '<option value="' + variant[i].id + '" ' + selected + '> ' + variant[i].variantName + ' </option>'
										}
										str += '</select>'
										str += '</div>'
										str += '<div class="form-group">'
										str += '<label>Product Initial</label>'
										str += '<input type="text" value="' + product.productInitial + '" class="form-control" id="productInitial">'
										str += '</div>'
										str += '<label>Product Name</label>'
										str += '<input type="text" value="' + product.productName + '"class="form-control" id="productName">'
										str += '</div>'
										str += '<label>Description</label>'
										str += '<input type="text" value="' + product.description + '" class="form-control" id="description">'
										str += '</div>'
										str += '<label>Price</label>'
										str += '<input type="number" value="' + product.price + '"class="form-control" id="price">'
										str += '</div>'
										str += '<label>Stock</label>'
										str += '<input type="number" value="' + product.stock + '"class="form-control" id="stock">'
										str += '</div>'
										str += '<div class="form-group form-check">'
										str += '<input type="checkbox" class="form-check-input" id="isActive" checked>'
										str += '<label for="isActive">Is Active</label>'
										str += '</div>'
										str += "</form>"

										$(".modal-title").html("Form Update Product")
										$(".modal-body").html(str)
										$("#btnSave").html("Update Product")
										$("#btnSave").off('click').on('click',
											function () {
												updateProduct(id)
											})
										$("#modal").modal('show')

										onChangeCategory() //Untuk change category(filter data variant berdasarkan category)
									}
								})
							}
						})

					}
				})
			}

			function updateProduct(id) {
				var formdata = '{'
				formdata += '"variantId":"' + $("#variantId").val() + '",'
				formdata += '"productInitial":"' + $("#productInitial").val() + '",'
				formdata += '"productName":"' + $("#productName").val() + '",'
				formdata += '"description":"' + $("#description").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ','
				formdata += '"price":"' + $("#price").val() + '",'
				formdata += '"stock":"' + $("#stock").val() + '"'
				formdata += '}'

				$.ajax({
					url: '/api/product/edit/' + id,
					data: formdata,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllProduct();
					}
				})
			}

			function f_delete(id) {
				$.ajax({
					url: '/api/product/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = '<h5>Apakah kamu yakin ingin menghapus data ini ?</h5>'
						str += '<center><b> Variant Name</b> : ' + data.variant.variantName + '</center>'
						str += '<center><b> Product Initial</b> : ' + data.productInitial + '</center>'
						str += '<center><b> Product Name</b> : ' + data.productName + '</center>'

						$(".modal-title").html("Delete Product")
						$(".modal-body").html(str)
						$("#btnSave").off('click').on('click',
							function () {
								deleteProduct(id)
							})
						$("#modal").modal('show')
					}
				})
			}
			
			function deleteProduct(id) {
				$.ajax({
					url: '/api/product/delete/' + id,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllProduct()
					}
				})
			}  
		</script>
	</div>
</body>

</html>